<template>
    <div>
      <div class="main">
        <h1> <img src=".././assets/cadastro.jpg" alt="cadastro" style="width: 100px"> <b>Cadastro de Passageiro</b></h1>
        <br>

            <ul>
            <li v-for="(erro, index) of errors" :key="index">
                campo <b> {{ erro.field }} </b> - {{ erro.defaultMessage }}
            </li>
            </ul>

        <form @submit.prevent="salvar">

            <div class="form-row">
                <div class="form-group col-md-6">
                    <label for="inputName">Nome Completo</label>
                    <input type="text" class="form-control" id="inputName" placeholder="Nome" v-model='passageiro.nome'>
                </div>
                <div class="form-group col-md-3">
                    <label for="inputName">CPF</label>
                    <input type="text" class="form-control" id="inputCPF" placeholder="CPF" v-model='passageiro.cpf'>
                </div>
                <div class="form-group col-md-3">
                    <label for="input">RG</label>
                    <input type="text" class="form-control" id="inputRG" placeholder="RG" v-model='passageiro.rg'>
                </div>
                <!-- --- -->
                <div class="form-group col-md-3">
                    <label for="input">Nascimento</label>
                    <input type="date" class="form-control" id="inputNascimento" placeholder="Nascimento" v-model='passageiro.nascimento'>
                </div>
                <div class="form-group col-md-3">
                    <label for="input">Telefone</label>
                    <input type="text" class="form-control" id="inputTelefone" placeholder="Telefone" v-model='passageiro.telefone'>
                </div>
                <div class="form-group col-md-3">
                    <label for="input">Endereço</label>
                    <input type="text" class="form-control" id="inputEndereco" placeholder="Endereço" v-model='passageiro.endereco'>
                </div>
                <div class="form-group col-md-3">
                    <label for="input">Cidade</label>
                    <input type="text" class="form-control" id="inputCidade" placeholder="Cidade" v-model='passageiro.cidade'>
                </div>
            </div>
            <button class="btn btn-primary">Enviar</button>
        </form>
      
      
      <div style='margin: 2%'>
        
        <h1> <img src=".././assets/passageiro.png" alt="passageiro"> Passageiros </h1>
        <!-- <router-link to='/motorista_add'>
            <button type="button" class="btn btn-primary">Cadastrar</button>
        </router-link> -->
        </div>
        
    <table class="table">
        <thead class="bg-success">
          <tr>
            <th>ID</th>
            <th>Nome</th>
            <th>CPF</th>
            <th>Ações</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="passageiro of passageiros" :key="passageiro.id">
            <td>{{ passageiro.id }}</td>
            <td>{{ passageiro.nome }}</td>
            <td>{{ passageiro.cpf }}</td>
            <td> <button type="button" @click="remover(passageiro)" class="btn btn-danger">Deletar</button>
            <button type="button" @click="editar(passageiro)" class="btn btn-info" style="margin-left: 2%">Editar</button> </td>
          </tr>
        </tbody>
    </table>
    </div>
    </div>
</template>


<script>

  import Passageiro from '../services/passageiros'
  import axios from 'axios'
  import { httpGet } from '../services/config'

  export default {

    data() {
      return {
        passageiro: {
          //"id": '',
          "viagem": null,
          "nome": '',
          "cpf": '',
          "rg": '',
          "nascimento": null,
          "telefone": '',
          "endereco": '',
          "cidade": ''
        },
        passageiros: [],
        errors: [],
      }
    },

    mounted() {
        this.listar()
    },

    methods:{

        listar() {
            Passageiro.listar().then(resposta => {
                this.passageiros = resposta.data
            })
        },

        salvar() {
            if(!this.passageiro.id) {
            Passageiro.salvar(this.passageiro).then(resposta => {
            console.log('Passageiro salvo com sucesso!')
            this.passageiro = {}
            this.errors = []
            this.listar()
          }).catch(e => {
            this.errors = e.response.data.errors
          })
          } else {
                Passageiro.atualizar(this.passageiro).then(resposta => {
                    this.passageiro = {}
                    alert('Passageiro Atualizado!')
                    this.errors = []
                    this.listar()
                }).catch(e => {
                    this.errors = e.response.data.errors
                })
            }
        },

        editar(passageiro) {
            this.passageiro = passageiro
        },

        remover(passageiro) {

            if (confirm('Deseja excluir o motorista?')) {
                axios.delete(httpGet() + '/passageiros/' + passageiro.id).then(resposta => {
                    this.errors = []
                    this.listar()
                }).catch(e => {
                    this.erros = e.response.data.errors
                })
            }
        }
    }

  }
</script>